package ca.uhn.fhir.jpa.interceptor.validation;

/*-
 * #%L
 * HAPI FHIR JPA Server
 * %%
 * Copyright (C) 2014 - 2021 Smile CDR, Inc.
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.util.List;

interface IRuleRoot {

	/**
	 * Starts a new rule that applies to any resources of type {@literal theType}
	 *
	 * @param theType The resource type e.g. "Patient" (must not be null)
	 */
	RepositoryValidatingRuleBuilder.RepositoryValidatingRuleBuilderTyped forResourcesOfType(String theType);

	/**
	 * Create the repository validation rules
	 */
	List<IRepositoryValidatingRule> build();

}
